% EE 192 Assignment 2
% Spring 2014
% Revision 2.1

clear; close all;

%% set simulation parameters
angle_limit = 30; % degrees
slew_rate_limit = 1000; % rad/s
default_car_velocity = 3; % m/s
car_length = 0.3; % m
noise_variance = 0; % m

%%% initial conditions
x0 = 0;
y0 = 0;
phi0 = 0;

%%% steering pid controller parameters
kp = 10;
kd = 0;
ki = 0;

%%% speed controller parameters
kp_vel = 5;
ki_vel = 0;
kd_vel = 0;

%%% speed controller error gain
kv = 0;

%% get track data
xTrack = [];
yTrack = [];

% Plot track segments individually
% f1 = @(x,y) -(sqrt((x)^2+(y-(-1))^2) - 1);
% trackSegments(:,1) = {f1;[-2 0 -2 0]};
t = 3*pi/2 : -0.1 : pi/2;
xTrack = [xTrack cos(t)];
yTrack = [yTrack sin(t)-1];

% f2 = @(x,y) -y;
% trackSegments(:,2) = {f2;[0 2 -1 0]};
xTrack = [xTrack 0 2];
yTrack = [yTrack 0 0];

% f3 = @(x,y) -y + 0.2;
% trackSegments(:,3) = {f3;[2 4 -1 1]};
xTrack = [xTrack 2 4];
yTrack = [yTrack 0.2 0.2];

% f4 = @(x,y) -(sqrt((x-4)^2+(y-(-0.9))^2) - 1.1);
% trackSegments(:,4) = {f4;[4 6 -2 1]};
t = pi/2 : -0.1 : -pi/2;
xTrack = [xTrack 1.1*cos(t)+4];
yTrack = [yTrack 1.1*sin(t)-0.9];

% f5 = @(x,y) y + 2;
% trackSegments(:,5) = {f5;[0 4 -2 -1]};
xTrack = [xTrack 4 0];
yTrack = [yTrack -2 -2];


%% run simulink model
TFinal = 15;
sim('simpleCarModel',TFinal);

%% plot simulation results
lapIndex = intersect(intersect(find(abs(x)<.1),find(abs(y)<.1)),find(time>2));
if(isempty(lapIndex))
    fprintf('\nTFinal may be too short. Lap on track has not been completed\n');
    lapIndex = length(x);
else
    lapIndex = lapIndex(1);
    fprintf('\nLap Time: %g seconds\n', time(lapIndex));
end

figure(1);
subplot(2,2,1); plot(x(1:lapIndex),y(1:lapIndex),'b',xTrack,yTrack,'r--');
hold on; plot(x0, y0, 'x'); % draw starting location
axis equal;
xlabel('x (m)'); ylabel('y (m)');
figureTitle1 = sprintf('matlab car simulation\n k_p = %d, k_d = %d, ', kp, kd);
figureTitle2 = sprintf('%.3g',noise_variance);
title([figureTitle1 '\sigma^2_{noise} = ' figureTitle2]);
legend('car','track')

subplot(2,2,2); plot(time(1:lapIndex),errorWithNoise(1:lapIndex));
figureTitle1 = sprintf('error signal with gaussian noise vs. time\n');
figureTitle2 = sprintf('%.3g',noise_variance);
title([figureTitle1 '\sigma^2_{noise} = ' figureTitle2]);
xlabel('time (s)'); ylabel('error (m)');

subplot(2,2,3); plot(time(1:lapIndex),delta(1:lapIndex));
title('steering angle \delta vs. time');
xlabel('time (s)'); ylabel('\delta (rad)');

subplot(2,2,4); plot(time(1:lapIndex),velocity(1:lapIndex));
figureTitle3 = sprintf('car velocity vs. time\n k_v = %.3g',kv);
title(figureTitle3);
xlabel('time (s)'); ylabel('v (m/s)');
